from django.contrib import admin
from django.urls import path,include
from wscubetech import views
from django.conf.urls.static import static
from django.conf import settings
from django.urls import path, re_path
from django.views.generic import RedirectView
from django.contrib.sitemaps.views import sitemap
from .sitemap import StaticViewSitemap
from django.conf.urls.i18n import i18n_patterns
from django.views.generic import TemplateView

sitemaps = {
    'posts': StaticViewSitemap,
}



urlpatterns = [
    
    path('sitemap.xml', sitemap, {'sitemaps': sitemaps},name='sitemap.xml'),
    path('sitemap-<section>.xml', sitemap, {'sitemaps': sitemaps}),
    path('admin', admin.site.urls, name='admin'),
    path("robots.txt",TemplateView.as_view(template_name="robots.txt", content_type="text/plain")), 
]
urlpatterns += i18n_patterns(
    path("linkedinurl/", include("linkedinurl.urls")),
    # path('sitemap.xml', sitemap, {'sitemaps': sitemaps},name='sitemap.xml'),
    # path('sitemap-<section>.xml', sitemap, {'sitemaps': sitemaps}),
    path('i18n/', include('django.conf.urls.i18n')),
    path('', views.homePage, name='home'),
    path('about-us', views.aboutUS, name='about-us'),
    path('services', views.services, name='services'),
    path('contact', views.submit_contact_form, name='contact'),
    path('news', views.news, name='news'),
    path('blog', views.blog, name='blog'),
    path('download', views.download, name='download'),
    path('how-to-copy-text-from-linkedin-post', views.LinkedinPost, name='how-to-copy-text-from-linkedin-post'),    
    path('linkedin-video-download', views.LinkedinVideo, name='linkedin-video-download'),
    path('linkedin-Image-download', views.LinkedinImage, name='linkedin-Image-download'),
    path('Ios17-latestFeature-releaseDate-SupportedDevice', views.news1, name='Ios17-latestFeature-releaseDate-SupportedDevice'),
    # path('online-linkedin-text-and-video-downloader', views.linkedin),

    path('privacy-policy', views.Privacy, name='privacy-policy'),
    path('terms-conditions', views.Terms, name='terms-conditions'),
    
    #Tool Pages
    path('video-downloader-converter', views.VideoDownloaderConverter,name='video-downloader-converter'),
    path('image-editing-tools', views.ImageEditingTools,name='image-editing-tools'),
    path('website-management-tools', views.WebsiteManagementTools,name='website-management-tools'),
    path('binary-converter-tools', views.BinaryConverterTools,name='binary-converter-tools'),
    
    # Downloader
    path('youtube-video-downloader', views.YoutubeVideoDownload, name="youtube-video-downloader"),
    path('ullu-webseries-download', views.ulluVideoDownload, name="ullu-webseries-download"),
    path('online-video-downloader', views.onlineVideoDownload, name="online-video-downloader"),
    path('linkedin-video-downloader', views.LinkedinVideoDownload, name="linkedin-video-downloader"),
    path('pinterest-video-downloader', views.pinterestVideoDownload, name="pinterest-video-downloader"),
    path('tiktok-video-downloader', views.tiktokVideoDownload, name="tiktok-video-downloader"),
    path('instagram-video-downloader', views.InstagramVideoDownload, name="instagram-video-downloader"),
    path('instagram-to-mp3', views.InstagramAudioDownload, name="instagram-to-mp3"),
    path('reddit-video-downloader', views.RedditVideoDownload, name="reddit-video-downloader"),
    path('imgur-video-downloader', views.ImgurVideoDownload, name="imgur-video-downloader"),
    path('bitchute-video-downloader', views.bitchuteVideoDownload, name="bitchute-video-downloader"),
    path('dailymotion-video-downloader', views.dailymotionVideoDownload, name="dailymotion-video-downloader"),
    path('snapchat-video-downloader', views.snapchatVideoDownload, name="snapchat-video-downloader"),
    path('bilibili-video-downloader', views.bilibiliVideoDownload, name="bilibili-video-downloader"),
    path('ted-video-downloader', views.tedVideoDownload, name="ted-video-downloader"),
    path('espn-video-downloader', views.espnVideoDownload, name="espn-video-downloader"),
    path('flickr-video-downloader', views.flickrVideoDownload, name="flickr-video-downloader"),
    path('ifunny-video-downloader', views.ifunnyVideoDownload, name="ifunny-video-downloader"),
    path('imdb-video-downloader', views.imdbVideoDownload, name="imdb-video-downloader"),
    path('mashable-video-downloader', views.mashableVideoDownload, name="mashable-video-downloader"),
    path('moj-video-downloader', views.mojVideoDownload, name="moj-video-downloader"),
    path('okru-video-downloader', views.okruVideoDownload, name="okru-video-downloader"),
    path('rumble-video-downloader', views.rumbleVideoDownload, name="rumble-video-downloader"),
    path('soundcloud-music-downloader', views.soundcloudVideoDownload, name="soundcloud-music-downloader"),
    path('vimeo-video-downloader', views.vimeoVideoDownload, name="vimeo-video-downloader"),
    path('vk-video-downloader', views.vkVideoDownload, name="vk-video-downloader"),
    path('twitch-clip-downloader', views.twitchVideoDownload, name="twitch-clip-downloader"),
    path('chingari-video-downloader', views.chingariVideoDownload, name="chingari-video-downloader"),
    path('9gag-video-downloader', views.ninegagVideoDownload, name="9gag-video-downloader"),
    path('izlesene-video-downloader', views.izleseneVideoDownload, name="izlesene-video-downloader"),
    path('sharechat-video-downloader', views.shareChatVideoDownload, name="sharechat-video-downloader"),
    path('tumblr-video-downloader', views.tumblrVideoDownload, name="tumblr-video-downloader"),
    path('facebook-video-downloader', views.FacebookVideoDownload, name="facebook-video-downloader"),
    path('twitter-video-downloader', views.TwitterVideoDownload, name="twitter-video-downloader"),
    path('xhamster-video-downloader', views.xhamsterVideoDownload, name="xhamster-video-downloader"),

    
    # YouTube Downloader & Converter
    path('youtube-shorts-downloader', views.YoutubeShortsDownload, name="youtube-shorts-downloader"),
    path('youtube-mp3', views.YoutubeToMp3, name="youtube-mp3"),
    path('youtube-mp4', views.YoutubeToMp4, name="youtube-mp4"),
    path('youtube-thumbnail-downloader', views.YoutubeThumbnailDownload, name="youtube-thumbnail-downloader"),

    # LinkedIn Text Copy & Downloader
    path('linkedin-image-downloader', views.LinkedinImageDownload, name="linkedin-image-downloader"),
    path('linkedin-pdf-downloader', views.LinkedinPdfDownload, name="linkedin-pdf-downloader"),
    path('linkedin-text-copy', views.LinkedinTextCopy, name="linkedin-text-copy"),

    # Image Editing Tool
    path('image-to-base64', views.ImageToBase64, name="image-to-base64"),
    path('base64-to-image', views.Base64ToImage, name="base64-to-image"),
    path('flip-image', views.FlipImage, name="flip-image"),
    path('rotate-image', views.RotateImage, name="rotate-image"),
    path('favicon-generator', views.FaviconGenerator, name="favicon-generator"),
    path('png-to-gif', views.PNGToGif, name="png-to-gif"),
    path('jpg-to-ico', views.JPGToICO, name="jpg-to-ico"),
    path('png-to-ico', views.PNGToICO, name="png-to-ico"),
    path('jpg-to-webp', views.JPGToWebP, name="jpg-to-webp"),
    path('png-to-webp', views.PNGToWebP, name="png-to-webp"),
    path('jpg-to-gif', views.JPGToGIF, name="jpg-to-gif"),
    path('webp-to-png', views.WebPToPNG, name="webp-to-png"),
    path('image-resizer', views.ImageResizer, name="image-resizer"),
    path('crop-image', views.CropImage, name="crop-image"),
    path('convert-to-jpg', views.ConvertToJPG, name="convert-to-jpg"),
    path('png-to-jpg', views.PNGToJPG, name="png-to-jpg"),
    path('jpg-to-png', views.JPGToPNG, name="jpg-to-png"),

    path('compress-jpeg-<str:platform>', views.ImageJPEGCompressor, name="compress-jpeg"),
    path('compress-image-<str:platform>', views.ImageCompressor, name="compress-image"),
    path('resize-image-<str:platform>', views.PhotoResizer, name="resize-image"),

    path('mb-to-kb-converter', views.MbToKbConverter, name="mb-to-kb-converter"),
    path('compress-jpg', views.CompressJpg, name="compress-jpg"),
    path('photo-resizer', views.singlePhotoResizer, name="photo-resizer"),

    # Binary Converter Tools
    path('text-to-binary', views.TextToBinary, name="TextToBinary"),
    path('binary-to-text', views.BinaryToText, name="BinaryToText"),
    path('hex-to-binary', views.HexToBinary, name="HexToBinary"),
    path('binary-to-hex', views.BinaryToHex, name="BinaryToHex"),
    path('ascii-to-binary', views.AsciiToBinary, name="AsciiToBinary"),
    path('binary-to-ascii', views.BinaryToAscii, name="BinaryToAscii"),
    path('decimal-to-binary', views.DecimalToBinary, name="DecimalToBinary"),
    path('binary-to-decimal', views.BinaryToDecimal, name="BinaryToDecimal"),
    path('text-to-ascii', views.TextToAscii, name="TextToAscii"),
    path('ascii-to-text', views.AsciiToText, name="AsciiToText"),
    path('hex-to-decimal', views.HexToDecimal, name="HexToDecimal"),
    path('decimal-to-hex', views.DecimalToHex, name="DecimalToHex"),
    path('octal-to-binary', views.OctalToBinary, name="OctalToBinary"),
    path('binary-to-octal', views.BinaryToOctal, name="BinaryToOctal"),
    path('octal-to-decimal', views.OctalToDecimal, name="OctalToDecimal"),
    path('decimal-to-octal', views.DecimalToOctal, name="DecimalToOctal"),
    path('hex-to-octal', views.HexToOctal, name="HexToOctal"),
    path('octal-to-hex', views.OctalToHex, name="OctalToHex"),
    path('text-to-octal', views.TextToOctal, name="TextToOctal"),
    path('octal-to-text', views.OctalToText, name="OctalToText"),
    path('text-to-hex', views.TextToHex, name="TextToHex"),
    path('hex-to-text', views.HexToText, name="HexToText"),
    path('text-to-decimal', views.TextToDecimal, name="TextToDecimal"),
    path('decimal-to-text', views.DecimalToText, name="DecimalToText"),
    path('rgb-to-hex', views.RgbToHex, name="RgbToHex"),
    path('hex-to-rgb', views.HexToRgb, name="HexToRgb"),

    #other tools
    path('word-to-excel-converter', views.WordToExcel, name="word-to-excel-converter"),
    path('number-to-word-converter', views.NumberToWord, name="number-to-word-converter"),
    path('cgpa-to-percentage-converter', views.CgpaToPercentage, name="cgpa-to-percentage-converter"),
    path('est-to-ist-converter', views.EstToIst, name="est-to-ist-converter"),
    # Website Management Tools
    path('url-encode', views.UrlEncode, name="url-encode"),
    path('url-decode', views.UrlDecode, name="url-decode"),
    path('html-beautifier', views.HtmlBeautifier, name="html-beautifier"),
    path('html-minifier', views.HtmlMinifier, name="html-minifier"),
    path('css-beautifier', views.CssBeautifier, name="css-beautifier"),
    path('css-minifier', views.CssMinifier, name="css-minifier"),
    path('javascript-beautifier', views.JavascriptBeautifier, name="javascript-beautifier"),
    path('javascript-minifier', views.JavascriptMinifier, name="javascript-minifier"),
    path('qr-code-decoder', views.QrCodeDecoder, name="qr-code-decoder"),
    path('qr-code-generator', views.QrCodeGenerator, name="qr-code-generator"),
    path('uuid-generator', views.UuidGenerator, name="uuid-generator"),
    path('url-parser', views.UrlParser, name="url-parser"),
    path('utm-builder', views.UtmBuilder, name="utm-builder"),

    # Development Tools
    path('json-viewer', views.JsonViewer, name="json-viewer"),
    path('json-formatter', views.JsonFormatter, name="json-formatter"),
    path('json-validator', views.JsonValidator, name="json-validator"),
    path('json-beautifier', views.JsonBeautifier, name="json-beautifier"),
    path('json-editor', views.JsonEditor, name="json-editor"),
    path('json-to-xml', views.JsonToXml, name="json-to-xml"),
    path('xml-to-json', views.XmlToJson, name="xml-to-json"),
    path('csv-to-json', views.CsvToJson, name="csv-to-json"),
    path('tsv-to-json', views.TsvToJson, name="tsv-to-json"),
    path('json-to-csv', views.JsonToCsv, name="json-to-csv"),
    path('json-to-text', views.JsonToText, name="json-to-text"),
    path('json-to-tsv', views.JsonToTsv, name="json-to-tsv"),


    # Online Calculators
    path('age-calculator', views.AgeCalculator, name='AgeCalculator'),
    path('percentage-calculator', views.PercentageCalculator, name='PercentageCalculator'),
    path('average-calculator', views.AverageCalculator, name='AverageCalculator'),
    path('confidence-interval-calculator', views.ConfidenceIntervalCalculator, name='ConfidenceIntervalCalculator'),
    path('sales-tax-calculator', views.SalesTaxCalculator, name='SalesTaxCalculator'),
    path('margin-calculator', views.MarginCalculator, name='MarginCalculator'),
    path('probability-calculator', views.ProbabilityCalculator, name='ProbabilityCalculator'),
    path('paypal-fee-calculator', views.PaypalFeeCalculator, name='PaypalFeeCalculator'),
    path('discount-calculator', views.DiscountCalculator, name='DiscountCalculator'),
    path('earnings-per-share-calculator', views.EarningsPerShareCalculator, name='EarningsPerShareCalculator'),
    path('cpm-calculator', views.CPMCalculator, name='CPMCalculator'),
    path('loan-to-value-calculator', views.LoanToValueCalculator, name='LoanToValueCalculator'),
    path('gst-calculator', views.GSTCalculator, name='GSTCalculator'),
    path('bmi-calculator', views.BMICalculator, name='BMICalculator'),
    path('chronological-age-calculator', views.ChronologicalAgeCalculator, name='ChronologicalAgeCalculator'),
    path('loan-calculator', views.LoanCalculator, name='LoanCalculator'),
    path('hours-calculator', views.HoursCalculator, name='HoursCalculator'),
    path('grade-calculator', views.GradeCalculator, name='GradeCalculator'),
    path('gpa-calculator', views.GPACalculator, name='GPACalculator'),
    path('percentage-increase-calculator', views.PercentageIncreaseCalculator, name='PercentageIncreaseCalculator'),
    path('percentage-decrease-calculator', views.PercentageDecreaseCalculator, name='PercentageDecreaseCalculator'),
    path('percentage-change-calculator', views.PercentageChangeCalculator, name='PercentageChangeCalculator'),
    path('percentage-difference-calculator', views.PercentageDifferenceCalculator, name='PercentageDifferenceCalculator'),
    path('calorie-calculator', views.CalorieCalculator, name='CalorieCalculator'),
    path('salary-calculator', views.SalaryCalculator, name='SalaryCalculator'),
    path('investment-calculator', views.InvestmentCalculator, name='InvestmentCalculator'),
    path('tdee-calculator', views.TDEECalculator, name='TDEECalculator'),
    # path('<path:invalid_path>', views.redirect_home, name='redirect_home'),
    path('<slug:slug>', views.BlogDetailView, name='blog-detail'),
    prefix_default_language=False

)+ static(settings.MEDIA_URL, document_root = settings.MEDIA_ROOT)

handler404 = 'wscubetech.views.error_404_view'